#ifndef ShapeCommand_First
#define ShapeCommand_First

#include "CmdNo.h"
#include "Command.h"
#include "Shapes.h"

const int cPATTERNMENU  =   cUSERCMD,
          cSETPATTERN   =   cUSERCMD + 100;

//---- PatternCommand ----------------------------------------------------------

class PatternCommand: public Command {
    Shape *shape;
    int oldPattern, newPattern;
public:
    MetaDef(PatternCommand);

    PatternCommand(Shape *s, int newpat);

    void DoIt()
        { shape->SetPattern(newPattern); }
    void UndoIt()
        { shape->SetPattern(oldPattern); }
};



//---- PatternMenuItem ---------------------------------------------------------

class PatternMenuItem : public VObject {
    int ink;
public:
    MetaDef(PatternMenuItem);

    PatternMenuItem(int id) : VObject(id+cSETPATTERN)
        { ink= id; SetExtent(Point(50, 20)); }
    void Draw(Rectangle)
        { GrPaintRect(contentRect.Inset(3), palette[ink]); }
};


#endif ShapeCommand_First
