//
// Shapes.C 
//
// 11.12.91 Ch.Frei
//

#include "ET++.h"
#include "GapText.h"
#include "Shapes.h"


//--- Shape --------------------------------------------------------------------

MetaImpl(Shape, (T(ink)));

void Shape::SetPattern(int newpat) 
{
    ink= newpat;
    ForceRedraw();
    Changed();
}

Command *Shape::DoLeftButtonDownCommand(Point, Token t, int)
{
    if (t.Flags & eFlgCntlKey)
	return GetStretcher();
    return GetMover();
}

ostream &Shape::PrintOn(ostream &s)
{
    VObject::PrintOn(s);
    return s << ink SP;
}

istream &Shape::ReadFrom(istream &s)
{
    VObject::ReadFrom(s);
    return s >> ink;
}

//---- BoxShape --------------------------------------------------------

MetaImpl0(BoxShape);

//---- OvalShape --------------------------------------------------------

MetaImpl0(OvalShape);

//---- TriangleShape --------------------------------------------------------

MetaImpl0(TriangleShape);

void TriangleShape::Draw(Rectangle r)
{ 
    Shape::Draw(r);
    
    Point corner[4];
    int n;
    n = 0;
    corner[n++] = contentRect.SW();
    corner[n++] = contentRect.N();
    corner[n++] = contentRect.SE();
    corner[n++] = contentRect.SW();
  
    GrFillPolygon(gPoint0, corner, n, ePolyDefault);
    GrStrokePolygon(gPoint0, corner, n, ePolyDefault);
}


//---- TextShape --------------------------------------------------------

MetaImpl(TextShape, (TP(tv), TP(tx)));

TextShape::TextShape(Rectangle r) : BoxShape(r)
{
    Init(new GapText((byte*)"an example of a textshape"));
}

TextShape::~TextShape()
{ 
    SafeDelete(tv); 
    SafeDelete(tx); 
}

void TextShape::Init(Text *t)
{
    Rectangle rr= contentRect.Inset(4);
    rr.extent.y= cFit;
    SafeDelete(tv);
    SafeDelete(tx);
    tx= t;
    tv= new TextView(this, rr, tx);
    Shape::SetExtent(tv->GetExtent() + gPoint4*2);
    tv->SetContainer(this);
    tv->SetFlag(eVObjLayoutCntl);
}

void TextShape::SetOrigin(Point at)
{
    Shape::SetOrigin(at);
    tv->SetOrigin(at+gPoint4);
}

void TextShape::SetExtent(Point e)
{
    tv->SetExtent(e-2*gPoint4);
}

void TextShape::Draw(Rectangle r)
{ 
    BoxShape::Draw(r);
    tv->DrawAll(r, FALSE);
}

void TextShape::Control(int, int part, void *op)
{
    if (op == tv && (part == cPartExtentChanged || part == cPartOriginChanged)) {
	ForceRedraw();
	contentRect= tv->ContentRect().Expand(4);
	ForceRedraw();
    }
}

Command *TextShape::DispatchEvents(Point p, Token &t, Clipper *vf)
{
    Command *cmd= tv->VObject::Input(p, t, vf);
    if (cmd)
	return cmd;
    return Shape::DispatchEvents(p, t, vf);
}

ostream &TextShape::PrintOn(ostream &s)
{ 
    BoxShape::PrintOn(s);
    return s << tv->GetText() SP;
}

istream &TextShape::ReadFrom(istream &s)
{ 
    Text *t;
    BoxShape::ReadFrom(s);
    s >> t;
    Init(t);
    return s;
}

void TextShape::Parts(Collection* col)
{
    Shape::Parts(col);
    col->Add(tv);
}

